<template>
  <v-container grid-list-md text-xs-center>
    <!-- <v-data-table :headers="labelList" :items="allNews" class="elevation-1"> -->
    <v-data-table :headers="headers" :items="users" class="elevation-1">
      <template v-slot:items="props">
        <!-- <td v-for="(user, index) in users" :key="index" class="text-center text-xs-center"></td> -->
        <td class="text-xs-center">{{ props.item.name }}</td>
        <td class="text-xs-right">{{ props.item.email }}</td>
        <td class="text-xs-right">
          <v-chip v-if="props.item.roles">{{props.item.roles}}</v-chip>
        </td>
        <td class="text-xs-right">
          <v-switch v-model="props.item.actif" color="success" :readonly="true"></v-switch>
        </td>

        <td class="text-xs-right">
          <v-btn small color="error" fab dark @click="deleteUser(props.item,props.index )">
            <v-icon>delete_outline</v-icon>
          </v-btn>

          <v-tooltip top>
            <template v-slot:activator="{ on }">
              <v-btn small color="info" fab dark v-on="on" @click="editUser(props.item)">
                <v-icon>border_color</v-icon>
              </v-btn>
            </template>
            <span>Editer</span>
          </v-tooltip>
        </td>
      </template>
    </v-data-table>

    <v-layout>
      <v-btn color="info" @click="create">Ajouter un utilisateur</v-btn>
    </v-layout>
    <v-snackbar
      v-model="snackbar"
      :bottom="y === 'bottom'"
      :left="x === 'left'"
      :multi-line="mode === 'multi-line'"
      :right="x === 'right'"
      :timeout="timeout"
      :top="y === 'top'"
      :vertical="mode === 'vertical'"
      :color="color"
    >
      {{ text }}
      <v-btn color="white" flat @click="snackbar = false">
        <v-icon>close</v-icon>
      </v-btn>
    </v-snackbar>
    <v-dialog v-model="dialog" persistent width="300">
      <v-card color="primary" dark>
        <v-card-text>
          Veuillez patienter
          <v-progress-linear indeterminate color="white" class="mb-0"></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
// import axios from "axios";
import { getHeader } from "@/config";
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_USERS_DELETE = URL_API + "api/users/delete/";
const URL_USERS_LIST = URL_API + "api/users/list";
export default {
  mounted: function() {
    this.fetchUsers();
  },
  data() {
    return {
      // snackbar
      dialog: false,
      snackbar: false,
      y: "top",
      x: null,
      mode: "",
      timeout: 6000,
      text: "",
      color: "pink",

      users: [],

      headers: [
        {
          text: "Nom",
          sortable: false,
          value: "Nom",
          align: "center"
        },
        {
          text: "Email",
          sortable: false,
          value: "Email",
          align: "center"
        },
        {
          text: "Rôle",
          sortable: false,
          value: "Rôle",
          align: "center"
        },
        {
          text: "Actif",
          sortable: false,
          value: "Actif",
          align: "center"
        },
        {
          text: "Actions",
          sortable: false,
          value: "Actions",
          align: "right"
        }
      ]
    };
  },
  methods: {
    editUser(pUser) {
      this.$router.push("/admin/users/edit/" + pUser.id);
    },
    deleteUser(pUser, pIndex) {
      self = this;
      this.$axios
        .delete(URL_USERS_DELETE + pUser.id, { headers: getHeader() })
        .then(response => {
          self.snackbar = true;
          if (response.data.data == "Suppression admin impossible") {
            self.text = "Suppression admin impossible";
          } else {
            self.text = "utilisateur supprimé";
            self.users.splice(pIndex, 1);
          }
        })
        .catch(error => {
          console.log("error", error);
        });
    },
    create() {
      this.$router.push("/admin/users/create");
    },
    fetchUsers() {
      this.$axios
        .get(URL_USERS_LIST, { headers: getHeader() })
        .then(response => {
          console.log("users = ", response.data);
          this.users = response.data.users;
        })
        .catch(error => {
          console.log("error", error);
        });
    }
  }
};
</script>
